/*


Copyright (C) 2004  Davide Carboni

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



var gnutella=window.arguments[0];

function connectCommand(){
	host=document.getElementById("node-name").value;
	port=document.getElementById("node-port").value;
	flushToLog("Connecting to "+host+" "+port);
	try{
		s=new GnutellaSocket(host,port);
		peerMessage=s.connect();
		flushToLog(peerMessage);
	}
	catch(ex){
		error(ex);
		return;
	}
	gnutella=window.arguments[0];
	
	if(s.responseCode=="200"){
		gnutella.connections[0]=s;
		updateConnectionView();
		startTimer(new Callback(s));
	}
	else{
		//addXTryToLocalCache();
	}
		
}

function discoveryCommand(){
	gatherWebCache();
/*	
	while(gnutella.localCache.length>0){
		peer=gnutella.localCache.shift();
		g=tryConnect(peer);
		if(g.isConnected())
			return g;
		else{
			saveXTryNodes(g.httpHeaders["X-Try"]);
		}
	}
*/
}

function gatherWebCache(){
	//s=new Socket("gwebcache3.jonatkins.org.uk",80);
	s=new Socket("localhost",80);
	//s.write("GET /perlgcache.cgi?hostfile=1\n\n");
	s.write("GET /prove/hosts.txt HTTP/1.1\n\n");

	webCache=s.readText();
	flushToLog("Web cache:\n"+webCache);
	
	gnutella.localCache=gnutella.localCache.concat(webCache.split("\n"));
	
}


function pingCommand(){
	try{		
		connection=gnutella.connections[0];
		connection.ping();
	}
	catch(ex){
		error(ex);
	}
}

function searchCommand(){
	query=document.getElementById("keywords").value;
	try{
		
		connection=gnutella.connections[0];
		queryUUID=connection.query(query);
		dump("searchCommand:queryUUID="+queryUUID);
		queryWindow=window.
		openDialog('chrome://pxulp/content/results.xul',query,"chrome,width=600,height=300",query);
		//register the query window in the gnutella global instance
		gnutella.queryWindows[queryUUID]=queryWindow;
		
	}
	catch(ex){
		error(ex);
	}
}

function downloadCommand(){
	tree=document.getElementById("result-tree");
	filename=tree.view.getCellText(tree.currentIndex,"file-name");
	index=tree.view.getCellText(tree.currentIndex,"file-index");
	hostname=tree.view.getCellText(tree.currentIndex,"source-host");
	port=tree.view.getCellText(tree.currentIndex,"source-port");
	window.open("http://"+hostname+":"+port+"/get/"+index+"/"+filename);
	
}


function Callback(socket){
	this.socket=socket;
	this.notify=function(timer){
			av=this.socket.available();
			if(av>0){
				try{
					flushToLog(av + " bytes in the stream\n");
					packet=new GnutellaPacket(uuid(16),0x00,0x00,0x00,[]);
					flushToLog("unmarshalling packet ...");
					packet.unmarshall(this.socket.input);
					flushToLog("done!\n");
					flushToLog("receiving packet of type "+packet.type+"\n\n");
					
					if(packet.type==0x00)
						this.socket.pong();
		
					if(packet.type==0x80)
						this.socket.queryHit();
					
					if(packet.type==0x81)
						processQueryHit(packet);
				}
				catch(e){
					error(e);
				}
			}
		}
}

function processQueryHit(packet){
	try{
		dump("processing query hit...");
		dumpHex(packet.payload);
		hit=new QueryHit(packet.payload);
		dump("done!\n");
		w=gnutella.queryWindows[packet.UUID];
		treeChildren=w.document.getElementById("result-tree-children");
		for(i=0;i<hit.numberOfHits;i++){
			item=w.document.createElement("treeitem");
			row=w.document.createElement("treerow");
			c1=w.document.createElement("treecell");
			c1.setAttribute("label",hit.IP);
			row.appendChild(c1);
			c2=w.document.createElement("treecell");
			c2.setAttribute("label",hit.port);
			row.appendChild(c2);
			c3=w.document.createElement("treecell");
			dump("\nprocessQueryHit:results="+hit.resultSet);
			c3.setAttribute("label",hit.resultSet.results[i].fileName);
			row.appendChild(c3);
			c4=w.document.createElement("treecell");
			c4.setAttribute("label",hit.resultSet.results[i].fileSize);
			row.appendChild(c4);
			c5=w.document.createElement("treecell");
			c5.setAttribute("label",hit.resultSet.results[i].index);
			row.appendChild(c5);
			item.appendChild(row);
			treeChildren.appendChild(item);
		}
		
	}
	catch(ex){
		error(ex);
	}
	
}

/**/

function updateConnectionView(){
	connections=gnutella.connections;
	connectionDOMNodes=document.getElementById("connections");
	numNodes=connectionDOMNodes.childNodes.length;
	for(k=0;k<numNodes;k++)
		connectionDOMNodes.removeChild(connectionDOMNodes.childNodes.item(k));
	for(k=0;k<connections.length;k++)
		addRowInConnectionTable(connections[k]);	
}

function addRowInConnectionTable(socket){
	connections=document.getElementById("connections");
	item=document.createElement("treeitem");
	item.setAttribute("id",socket.host+":"+socket.port);
	row=document.createElement("treerow");
	cell=document.createElement("treecell");
	cell.setAttribute("label",socket.host+":"+socket.port);
	row.appendChild(cell);
	cell=document.createElement("treecell");
	cell.setAttribute("label",socket.host);
	row.appendChild(cell);
	item.appendChild(row);
	connections.appendChild(item);
}
/**/


function flushToLog(msg){
	logbox=document.getElementById("log-box");
	logbox.value=logbox.value+msg+"\n";
	dump(msg+"\n");
}



function startTimer(callback){
	if(gnutella.timer == null){
		flushToLog("starting timer ..."); timer=Components.classes["@mozilla.org/timer;1"].getService(Components.interfaces.nsITimer);
		timer.initWithCallback(callback, 1000,1);
		gnutella.timer=timer;
	}
	else{
		flushToLog("timer already running ...");
	}
}

function error(exception){
	alert(exception);
	gnutella.connections=[];
	updateConnectionView();
	throw exception;
}
