/*


Copyright (C) 2004  Davide Carboni

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/** Original file /home/davide/pxulp/content/socket.js **/


function toBigEndian(number,num_bytes){
		b=new Array(num_bytes);
		for(i=0;i<num_bytes;i++){
			a=0xff << (8*(num_bytes-1-i));
			n=number & a;
			n >> (8*(num_bytes-1-i));
			b[i]=n;
		}
		return b;
}

function toLittleEndian(number,num_bytes){
	return toBigEndian(number,num_bytes).reverse();
}

function pop8(byteArray){
	return byteArray.shift();
}

function pop16(byteArray){
	return pop8(byteArray)+pop8(byteArray)*0x100;
}

function pop32(byteArray){
	return pop16(byteArray)+pop16(byteArray)*0x10000;
}

function pop64(byteArray){
	return pop32(byteArray)+pop32(byteArray)*0x100000000;
}

function popString(byteArray){
	s="";
	b=pop8(byteArray);
	while(b!=0x00){
		s=s+String.fromCharCode(b);
		b=pop8(byteArray);
	}
	return s;
}


function string2ByteArray(s){
	a=new Array();
	for(i=0;i<s.length;i++){
		a.push(s.charCodeAt(i));
	}
	return a;
}


/**
$Socket class$
Copyright Davide Carboni 2004
*
*/

function Socket (host,port)
{
    this.host = host;
    this.port = port;

    var transportService =
      Components.classes["@mozilla.org/network/socket-transport-service;1"]
        .getService(Components.interfaces.nsISocketTransportService);
    
    this.transport = transportService.createTransport(null,0,host,port,null);
    
    var stream;
    var instream;
    
    //openFlags = Components.interfaces.nsITransport.OPEN_BLOCKING;
    o=this.transport.openOutputStream(0,0,0);
    
    this.output=Components.classes["@mozilla.org/binaryoutputstream;1"]
	      .createInstance(Components.interfaces.nsIBinaryOutputStream);
    
    this.output.setOutputStream(o);

    i = this.transport.openInputStream(0, 0, 0);
    
    this.input = Components.classes["@mozilla.org/binaryinputstream;1"]
      .createInstance(Components.interfaces.nsIBinaryInputStream);
     this.input.setInputStream(i);
    

}

Socket.prototype.isAlive=function(){
	return this.transport.isAlive();
}


Socket.prototype.writeByte=function(aByte){
	this.output.write8(aByte);
	this.output.flush();
}



Socket.prototype.write=function(data){
	this.output.write(data,data.length);
	this.output.flush();
}

Socket.prototype.readText=function(){
	var k=this.input.available();
	text="";
	for(i=0;i<k;i++)
		text=text+String.fromCharCode(this.readByte());
	return text;
}

Socket.prototype.readByte=function(){
	return this.input.read8();
}

Socket.prototype.readWord=function(){
	return this.input.read16();
}

Socket.prototype.readDWord=function(){
	return this.input.read32();
}

Socket.prototype.available=function(){
	return this.input.available();
}




Socket.prototype.close=function(){
	this.input.close();
	this.output.close();
	this.transport.close("");
}


function pause(millis){
    var threadclass=Components.classes["@mozilla.org/thread;1"].getService(Components.interfaces.nsIThread);
    threadclass.currentThread.sleep(millis);
}


function dec2hex(n){
        // 0xXY
        chars=['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'];
        X= ((n&0xf0)>>4);
        Y= (n&0x0f);
        return ""+chars[X]+chars[Y];

}

function dumpHex(byteArray){
	dump("\n"+byteArray.length);
	dump("\n----------------------------------\n");
	s="";
	for(i=0;i<byteArray.length;i++) {
		if(i%16==0){
			dump("\t\t"+s+"\n");
			s="";
		}

		b=byteArray[i];
		s=s+ ( (b>=0x20 && b<= 0x80) ? (String.fromCharCode(b)) : ".");
		dump(dec2hex(b)+" ");
	}
}

